package tk.glover.jsfunittest.entity.dbhelper;

import java.util.List;

import javax.persistence.EntityManager;

import tk.glover.jsfunittest.model.Suburbs;

/**
 * This class provides access to helper tables.
 * @author andrew glover 
 */
public interface DBHelperEntity {
	
	/**
	 * Refresh.
	 * 
	 * @param obj the obj
	 */
	public void refresh(Object obj);

	/**
	 * Validate suburb postcode.
	 * 
	 * @param suburb the suburb
	 * @param postcode the postcode
	 * @param state the state
	 * 
	 * @return true, if successful
	 */
	public boolean validateStateSuburbPostcode(String state, String suburb, String postcode);

	/**
	 * Autocomplete suburb.
	 * 
	 * @param suburb the suburb
	 * 
	 * @return the list< suburb search result>
	 * 
	 * @throws Exception the exception
	 */
	public List<Suburbs> autocompleteSuburb(String suburb) throws Exception;
	
	
	/**
	 * Autocomplete postcode.
	 * 
	 * @param postcode the postcode
	 * 
	 * @return the list< suburb search result>
	 * 
	 * @throws Exception the exception
	 */
	public List<Suburbs>autocompletePostcode(String postcode) throws Exception;
		
    /**
     * Gets the next sequence.
     * 
     * @param seqName the seq name
     * 
     * @return the next sequence
     */
    public Long getNextSequence(String seqName);
    
	/**
	 * Gets the em.
	 * 
	 * @return the em
	 */
	public EntityManager getEm();
}
