package tk.glover.jsfunittest.entity.dbhelper;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;

import tk.glover.jsfunittest.model.RevenueType;

/**
 * The Class RevenueTypeUtil.
 * @author andrew glover
 */
@Name("revenueTypeUtil")
@Scope(ScopeType.APPLICATION)
public class RevenueTypeUtil {

    public static final List<String> REGISTRABLE_REVENUE_TYPES = Arrays.asList("CA", "CH", "CC", "LO");

    public static String CASH = "CA", CHEQUE = "CH", CREDIT_CARD = "CC", LOTTERY = "LO";

    /**
     * Gets the revenue type.
     * 
     * @param type
     *            the type
     * 
     * @return the revenue type
     */
    public static RevenueType getRevenueType(String type) {
        // revenue types that's not defined in xml
        for (RevenueType rte : getRevenueTypeEntities()) {
            if (rte.getType().equals(type)) {
                RevenueType rt = new RevenueType();
                rt.setLabel(rte.getLabel());
                rt.setType(rte.getType());
                return rt;
            }
        }
        return null;
    }

    public static List<RevenueType> getRevenueTypeEntities() {
        List<RevenueType> rts = new ArrayList<RevenueType>();
        rts.add(new RevenueType("CA", "Cash"));
        rts.add(new RevenueType("CH", "Cheque"));
        rts.add(new RevenueType("CC", "Credit Card"));
        rts.add(new RevenueType("LO", "Lottery"));
        return rts;
    }
}
