package tk.glover.jsfunittest.model;

import java.io.Serializable;

/**
 * The Class GenericType.
 * 
 * @author andrew glover
 */
public class GenericType implements Comparable<GenericType>, Serializable {

    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = 1963230056640688931L;

    /** The type. */
    private String type;

    /** The label. */
    private String label;

    /**
     * Gets the type.
     * 
     * @return the type
     */
    public String getType() {
        return type;
    }

    /**
     * Sets the type.
     * 
     * @param type
     *            the new type
     */
    public void setType(String type) {
        this.type = type;
    }

    /**
     * Gets the label.
     * 
     * @return the label
     */
    public String getLabel() {
        return label;
    }

    /**
     * Sets the label.
     * 
     * @param label
     *            the new label
     */
    public void setLabel(String label) {
        this.label = label;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((type == null) ? 0 : type.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        GenericType other = (GenericType) obj;
        if (type == null) {
            if (other.type != null)
                return false;
        } else if (!type.equals(other.type))
            return false;
        return true;
    }

    @Override
    public int compareTo(GenericType obj) {
        if (obj == null) {
            return 1;
        }

        GenericType t1 = this;
        GenericType t2 = obj;
        if (t1.getLabel() == null) {
            return -1;
        } else if (t2.getLabel() == null) {
            return 1;
        }

        return t1.label.compareTo(t2.label);
    }

    @Override
    public String toString() {
        return this.label;
    }

}
