package tk.glover.jsfunittest.service;

import java.util.List;

import javax.ejb.Stateless;

import org.jboss.seam.annotations.AutoCreate;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;

import tk.glover.jsfunittest.entity.dbhelper.DBHelperEntity;
import tk.glover.jsfunittest.model.Suburbs;

/**
 * The Class DBHelperServiceImpl.
 * 
 * @author andrew glover
 */
@Stateless
@AutoCreate
@Name("dbHelperService")
public class DBHelperServiceImpl implements DBHelperService {

    /** The db helper entity. */
    @In
    DBHelperEntity dbHelperEntity;

    @Override
    public List<Suburbs> autocompletePostcode(String postcode) throws Exception {
        return dbHelperEntity.autocompletePostcode(postcode);
    }

    /** {@inheritDoc} */
    @Override
    public List<Suburbs> autocompleteSuburb(String suburb) throws Exception {
        return dbHelperEntity.autocompleteSuburb(suburb);
    }

    /** {@inheritDoc} */
    @Override
    public boolean validateStateSuburbPostcode(String state, String suburb, String postcode) {
        return dbHelperEntity.validateStateSuburbPostcode(state, suburb, postcode);
    }

    /** {@inheritDoc} */
    @Override
    public Long getNextSequence(String seqName) {
        return dbHelperEntity.getNextSequence(seqName);
    }

    /** {@inheritDoc} */
    @Override
    public void refresh(Object obj) {
        dbHelperEntity.refresh(obj);
    }

    /** {@inheritDoc} */
    @Override
    public void flush() {
        dbHelperEntity.getEm().flush();
    }

}
