package tk.glover.jsfunittest.session;

import java.io.Serializable;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.AutoCreate;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.core.Expressions;

/**
 * Backing class for Delete popup page.
 * 
 * @author andrew glover
 */
@Name("deletePopup")
@Scope(ScopeType.PAGE)
@AutoCreate
public class DeletePopupBacking implements Serializable {

    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = -5063082673746411892L;

    /** The title. */
    private String title;

    /** The re render ids. */
    private String reRenderIds;

    /** The yes callback. */
    private String yesCallback;

    /** The no callback. */
    private String noCallback;

    /** The delete label. */
    private String deleteLabel;

    /** The replace label. */
    private boolean replaceLabel;

    /**
     * Yes action.
     */
    public void yesAction() {
        if (yesCallback != null) {
            Expressions.instance().createMethodExpression(yesCallback).invoke();
        }
    }

    /**
     * No action.
     */
    public void noAction() {
        if (noCallback != null) {
            Expressions.instance().createMethodExpression(noCallback).invoke();
        }
    }

    /**
     * Gets the title.
     * 
     * @return the title
     */
    public String getTitle() {
        return title;
    }

    /**
     * Sets the title.
     * 
     * @param title
     *            the new title
     */
    public void setTitle(String title) {
        this.title = title;
    }

    /**
     * Sets the no callback.
     * 
     * @param noCallback
     *            the new no callback
     */
    public void setNoCallback(String noCallback) {
        this.noCallback = noCallback;
    }

    /**
     * Gets the re render ids.
     * 
     * @return the re render ids
     */
    public String getReRenderIds() {
        return reRenderIds;
    }

    /**
     * Sets the re render ids.
     * 
     * @param reRenderIds
     *            the new re render ids
     */
    public void setReRenderIds(String reRenderIds) {
        this.reRenderIds = reRenderIds;
    }

    /**
     * Sets the yes callback.
     * 
     * @param yesCallback
     *            the new yes callback
     */
    public void setYesCallback(String yesCallback) {
        this.yesCallback = yesCallback;
    }

    /**
     * Gets the delete label.
     * 
     * @return the delete label
     */
    public String getDeleteLabel() {
        return deleteLabel;
    }

    /**
     * Sets the delete label.
     * 
     * @param deleteLabel
     *            the new delete label
     */
    public void setDeleteLabel(String deleteLabel) {
        this.deleteLabel = deleteLabel;
    }

    /**
     * Checks if is replace label.
     * 
     * @return true, if is replace label
     */
    public boolean isReplaceLabel() {
        return replaceLabel;
    }

    /**
     * Sets the replace label.
     * 
     * @param replaceLabel
     *            the new replace label
     */
    public void setReplaceLabel(boolean replaceLabel) {
        this.replaceLabel = replaceLabel;
    }
}
