package tk.glover.jsfunittest.session;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.annotations.intercept.BypassInterceptors;

import tk.glover.jsfunittest.entity.dbhelper.RevenueTypeUtil;
import tk.glover.jsfunittest.model.RevenueType;

/**
 * The Class RevenueTypeConverter.
 * 
 * @author andrew glover
 */
@Name("reveueTypeConverter")
@BypassInterceptors
@org.jboss.seam.annotations.faces.Converter
@Scope(ScopeType.APPLICATION)
public class RevenueTypeConverter implements Converter {

    @Override
    public Object getAsObject(FacesContext arg0, UIComponent arg1, String str) {
        RevenueType rt = RevenueTypeUtil.getRevenueType(str);
        return rt;
    }

    @Override
    public String getAsString(FacesContext arg0, UIComponent arg1, Object obj) {
        String val;
        if (obj != null) {
            if (obj instanceof RevenueType) {
                val = ((RevenueType) obj).getType();
            } else {
                val = obj.toString(); // default behaviour
            }
        } else {
            val = "";
        }
        return val;
    }

}
