package tk.glover.jsfunittest.session;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.AutoCreate;
import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.End;
import org.jboss.seam.annotations.FlushModeType;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;

import tk.glover.jsfunittest.entity.dbhelper.RevenueTypeUtil;
import tk.glover.jsfunittest.model.RevenueType;
import tk.glover.jsfunittest.service.DBHelperService;

@AutoCreate
@Name("suggestionOnModalPanel")
@Scope(ScopeType.CONVERSATION)
public class SuggestionOnModalPanel implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 582267466153328675L;

	/** The db service. */
	@In
	private DBHelperService dbHelperService;

	/** The mars config. */
	@In
	private ProjectConfig projectConfig;

	@In(required = false)
	@Out(required = false)
	private String revenueType;
    
	/**
	 * Load page. This does noting other than mimic the flow of the actual
	 * project
	 * 
	 * @return the string
	 */
	@Begin(nested = true, flushMode = FlushModeType.MANUAL)
	public String loadpage() {
		return "suggestionOnModalPanel";
	}

	public void changeRevenueType() {
		String a1 = this.revenueType;
	}
	
	public String done() {
		return "home";
	}

	/**
	 * Cancel.
	 * 
	 * @return the string
	 */
	@End(beforeRedirect = true)
	public String cancel() {
		return "home";
	}

	public List<RevenueType> getAvailableRevenueTypes() {
        List<String> types = new ArrayList<String>(RevenueTypeUtil.REGISTRABLE_REVENUE_TYPES);
		List<RevenueType> rts = new ArrayList<RevenueType>();

        for (String type : types) {
            rts.add(RevenueTypeUtil.getRevenueType(type));
        }	
		

		Collections.sort(rts);
		return rts;
	}

}
