package tk.glover.jsfunittest.session;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.hibernate.util.SerializationHelper;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.AutoCreate;
import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.End;
import org.jboss.seam.annotations.FlushModeType;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.core.Conversation;
import org.jboss.seam.international.StatusMessage;
import org.jboss.seam.international.StatusMessages;
import org.jboss.seam.international.StatusMessage.Severity;

import tk.glover.jsfunittest.entity.dbhelper.RevenueTypeUtil;
import tk.glover.jsfunittest.model.Address;
import tk.glover.jsfunittest.model.RevenueType;
import tk.glover.jsfunittest.service.DBHelperService;

@AutoCreate
@Name("suggestionOnModalPanelSimple")
@Scope(ScopeType.CONVERSATION)
public class SuggestionOnModalPanelSimple implements Serializable {

    /**
	 * 
	 */
    private static final long serialVersionUID = 582267466153328675L;

    /** The db service. */
    @In
    private DBHelperService dbHelperService;

    /** The mars config. */
    @In
    private ProjectConfig projectConfig;

    /**
     * Load page. This does noting other than mimic the flow of the actual project
     * 
     * @return the string
     */
    @Begin(nested = true, flushMode = FlushModeType.MANUAL)
    public String loadpage() {
        return "suggestionOnModalPanelSimple";
    }

    public String done() {
        return "home";
    }

    /**
     * Cancel.
     * 
     * @return the string
     */
    @End(beforeRedirect = true)
    public String cancelPage() {
        return "home";
    }

}
