package tk.glover.jsfunittest.session;

import java.io.Serializable;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.AutoCreate;
import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.FlushModeType;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;

import tk.glover.jsfunittest.model.Address;
import tk.glover.jsfunittest.service.DBHelperService;


@AutoCreate
@Name("suggestionOnPage")
@Scope(ScopeType.CONVERSATION)
public class SuggestionOnPage  implements Serializable {

	private static final long serialVersionUID = 142460171514410077L;

	/** The db service. */
	@In
	private DBHelperService dbHelperService;

	/** The mars config. */
	@In
	private ProjectConfig projectConfig;

    /** The address. */
    private Address address;

    /**
	 * Load page.
	 * This does noting other than mimic the flow of the actual project
	 * @return the string
	 */
	@Begin(nested = true, flushMode = FlushModeType.MANUAL)
	public String loadpage() {
        address = new Address();
        address.setId(1L);
		return "suggestionOnPage";
	}

	public String done() {
		return "home";
	}
	
    public Address getAddress() {
        return address;
    }

    public void setAddress(Address address) {
        this.address = address;
    }

}
