package tk.glover.jsfUnitTest.test.login;

import org.jboss.jsfunit.jsfsession.JSFClientSession;
import org.jboss.jsfunit.jsfsession.JSFServerSession;
import org.jboss.jsfunit.jsfsession.JSFSession;

import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * The Class LoginTest.
 */
public class LoginTest extends org.apache.cactus.ServletTestCase {

    /** Get the name of the test case class. */
    private final String className = this.getClass().getSimpleName();

    /**
     * Suite.
     * 
     * @return the test
     */
    public static Test suite() {
        return new TestSuite(LoginTest.class);
    }

    /**
     * Test login.
     * 
     * @throws Exception
     *             the exception
     */
    public void testLogin() throws Exception {
        String testName = className + ":" + this.getName() + " - ";

        // Send an HTTP request for the initial page
        JSFSession jsfSession = new JSFSession("/login.seam");

        // A JSFClientSession emulates the browser and lets you test HTML
        JSFClientSession jsfClientSession = jsfSession.getJSFClientSession();

        // A JSFServerSession gives you access to JSF state
        JSFServerSession jsfServerSession = jsfSession.getJSFServerSession();

        jsfClientSession.setValue("username", "admin");
        jsfClientSession.setValue("password", "admin");
        jsfClientSession.click("m3_submit");
        Object userBeanValue = jsfServerSession.getManagedBeanValue("#{identity.username}");

        assertEquals(testName + "Invalid user found", "admin", userBeanValue);
        String textRequired = "Welcome to Seam!";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));
    }

    /**
     * Test logout.
     * 
     * @throws Exception
     *             the exception
     */
    public void testLogout() throws Exception {
        String testName = className + ":" + this.getName() + " - ";

        // Send an HTTP request for the initial page
        JSFSession jsfSession = new JSFSession("/login.seam");

        // A JSFClientSession emulates the browser and lets you test HTML
        JSFClientSession jsfClientSession = jsfSession.getJSFClientSession();

        // A JSFServerSession gives you access to JSF state
        JSFServerSession jsfServerSession = jsfSession.getJSFServerSession();

        jsfClientSession.setValue("username", "admin");
        jsfClientSession.setValue("password", "admin");
        jsfClientSession.click("m3_submit");
        Object userBeanValue = jsfServerSession.getManagedBeanValue("#{identity.username}");

        assertEquals(testName + "Invalid user found", "admin", userBeanValue);
        String textRequired = "Welcome to Seam!";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        // Log out
        jsfClientSession.click("m4_logout_btn");
        textRequired = "Remember me";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

    }

}
