package tk.glover.jsfUnitTest.test.suggestion;

import junit.framework.Test;
import junit.framework.TestSuite;
import tk.glover.jsfUnitTest.test.BaseTest;

/**
 * The Class A001_TestNavigation. <br>
 * Test that the rich:suggestion is working in an xhtml page. <br>
 * 
 * @author Andrew Glover
 */
public class A001_TestOnPage extends BaseTest {

    /** Get the name of the test case class */
    public final String className = this.getClass().getSimpleName();

    public static Test suite() {
        return new TestSuite(A001_TestOnPage.class);
    }

    /**
     * Login and navigate to suggestionOnPage and select a suburb, click Ok.<br>
     * 
     * @throws Exception
     */
    public void testSuggestionOnPage() throws Exception {
        String testName = className + ":" + this.getName() + " - ";

        jsfClientSession.click("m4_on_page");

        String textRequired = "Suggestion Box on Page";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        jsfClientSession.setValue("m7_address_suburb", "brooke");

        // TODO How do you select a line from the suggestion box!

        textRequired = "brooke";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        logout();

    }

    private void logout() throws Exception {
        String testName = className + ":" + this.getName() + " - ";

        /** m4 - menu.xhtml **/
        jsfClientSession.click("m4_logout_btn");

        String textRequired = "Remember me";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

    }
}
