package tk.glover.jsfUnitTest.test.suggestion;

import junit.framework.Test;
import junit.framework.TestSuite;
import tk.glover.jsfUnitTest.test.BaseTest;

import com.gargoylesoftware.htmlunit.html.HtmlSelect;

/**
 * The Class A002_TestOnModalPanel. <br>
 * Test that the rich:suggestion is working on a modal panel, this is complex navigation to get to the pop-up. <br>
 * This mirrors the actual application
 * 
 * @author Andrew Glover
 */
public class A002_TestOnModalPanel extends BaseTest {

    /** Get the name of the test case class */
    public final String className = this.getClass().getSimpleName();

    public static Test suite() {
        return new TestSuite(A002_TestOnModalPanel.class);
    }

    /**
     * Login and navigate to suggestionOnModalPanel<br>
     * <br>
     * @throws Exception
     */
    public void testSuggestionOnModalPanel() throws Exception {
        String testName = className + ":" + this.getName() + " - ";

        /** m4 - Menu.xhtml **/
        jsfClientSession.click("m4_on_modalpane");

        String textRequired = "Suggestion Box on Modal Pane";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        HtmlSelect select = (HtmlSelect) jsfClientSession.getElement("m8_register_revenue_type");
        select.getOptionByValue("CC").setSelected(true);

        textRequired = "Addresses";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));
        
        jsfClientSession.click("m12_client_address_manager_btn");

        textRequired = "Manage Client Address";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));
        
        jsfClientSession.click("m13_add_client_address_btn");

        textRequired = "Add Address";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        // TODO How do you select a line from the suggestion box!
        
        jsfClientSession.click("m14_cancel");

        textRequired = "Manage Client Address";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        jsfClientSession.click("m13_cancel");

        textRequired = "Suggestion Box on Modal Pane";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        jsfClientSession.click("m7_cancel");

        textRequired = "Welcome to Seam!";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        logout();

    }

    private void logout() throws Exception {
        String testName = className + ":" + this.getName() + " - ";

        /** m4 - menu.xhtml **/
        jsfClientSession.click("m4_logout_btn");

        String textRequired = "Remember me";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

    }
}
