package tk.glover.jsfUnitTest.test.suggestion;

import junit.framework.Test;
import junit.framework.TestSuite;
import tk.glover.jsfUnitTest.test.BaseTest;

import com.gargoylesoftware.htmlunit.html.HtmlSelect;

/**
 * The Class A002_TestOnModalPanel. <br>
 * Test that the rich:suggestion is working on a modal panel invoked directly from a page. <br>
 * 
 * @author Andrew Glover
 */
public class A003_TestOnModalPanelSimple extends BaseTest {

    /** Get the name of the test case class */
    public final String className = this.getClass().getSimpleName();

    public static Test suite() {
        return new TestSuite(A003_TestOnModalPanelSimple.class);
    }

    /**
     * Login and navigate to suggestionOnModalPanel<br>
     * <br>
     * @throws Exception
     */
    public void testSuggestionOnModalPanel() throws Exception {
        String testName = className + ":" + this.getName() + " - ";

        /** m4 - Menu.xhtml **/
        jsfClientSession.click("m4_on_modalpaneSimple");

        String textRequired = "Suggestion Box on Modal Pane Simple";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));
        
        jsfClientSession.click("m10_add_client_address_btn");

        textRequired = "Add Address";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        // TODO How do you select a line from the suggestion box!
        
        jsfClientSession.click("m14_cancel");


        textRequired = "Suggestion Box on Modal Pane Simple";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        jsfClientSession.click("m7_cancel");

        textRequired = "Welcome to Seam!";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

        logout();

    }

    private void logout() throws Exception {
        String testName = className + ":" + this.getName() + " - ";

        /** m4 - menu.xhtml **/
        jsfClientSession.click("m4_logout_btn");

        String textRequired = "Remember me";
        assertTrue(testName + "Text not found on page - " + textRequired, jsfClientSession.getPageAsText().contains(textRequired));

    }
}
